/*-
 * Copyright (c) 2000 Joao Cabral (jcnc@dhis.org)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *      WHOIS Client Release 1.0
 */

#include<stdio.h>
#include<ctype.h>
#include<string.h>
#include<stdlib.h>
#include<sys/socket.h>
#include<netdb.h>
#include<netinet/in.h>
#include<arpa/inet.h>

#define	DEF_SERVER	"whois.dhis.org"

extern char *optarg;
extern int optind;

void errorm(void) {

	fprintf(stderr,"Usage: whois [-h server] string\n");
	exit(1);
}

main(int argc,char *argv[]) {

	int c,i;
	unsigned char host[256];
	struct hostent *hp;
	int addr;
	struct sockaddr_in sa;
	unsigned char buff[1024];

	strcpy(host,DEF_SERVER);

	while((c=getopt(argc,argv,"h:"))!=EOF) {
	switch(c) {
	case('h'): 	strcpy(host,optarg); break;
	default: 	errorm();
	}
	}

	if(argc==1) errorm();
	if(argv[optind]==NULL) errorm();
	if(argv[optind][0]=='\0') errorm();

	if(optind == argc) errorm();
	

	hp=gethostbyname(host);
	if(hp==NULL) {
		fprintf(stderr,"\nUnable to resolve %s\n\n",host);
		exit(2);
	}
	sa.sin_addr.s_addr=(*(int *)hp->h_addr);
	sa.sin_port=htons(43);
	sa.sin_family=AF_INET;
	
	c=socket(AF_INET,SOCK_STREAM,0);
	if(c<0) {
		fprintf(stderr,"\nUnable to create socket.\n\n");
		exit(3);
	}

	if(connect(c,(struct sockaddr *)&sa,sizeof(struct sockaddr_in))) {
		fprintf(stderr,"\nConnection refused.\n\n");
		close(c);
		exit(4);
	}

	sprintf(buff,"%s\r\n",argv[optind]);
	write(c,buff,strlen(buff));
	while((i=read(c,buff,1024))>0) 
		write(1,buff,i);
	close(c);
	exit(0);
}
